package com.galaxis.manatee.dao;

import com.galaxis.capsule.util.GalaxisRepository;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunSubWorkHourDO;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.time.LocalDateTime;
import java.util.List;

@Repository
public interface ChuanyunSubWorkHourDao extends GalaxisRepository<ChuanyunSubWorkHourDO,String> {

    /**
     * 获取子项目每日工时
     * @param userId
     * @return
     */
    @Query(value="SELECT\n" +
            "\tchuanyun_day_log.object_id,\n" +
            "\tSUM(\n" +
            "\t\tchuanyun_day_log.hours_worked\n" +
            "\t) AS hours_worked,\n" +
            "\tchuanyun_day_log.sub_porject_id AS project_id,\n" +
            "\tchuanyun_day_log.project_type,\n" +
            "\tchuanyun_log.user_id,\n" +
            "\tchuanyun_log.department_name,\n" +
            "\tchuanyun_day_log.sub_project_bg AS bg,\n" +
            "\tchuanyun_log. STATUS,\n" +
            "\tchuanyun_day_log.day_log_date\n" +
            "FROM\n" +
            "\tchuanyun_day_log\n" +
            "LEFT JOIN chuanyun_log ON chuanyun_day_log.parent_object_id = chuanyun_log.object_id\n" +
            "WHERE\n" +
            "\tchuanyun_log.user_id = ?\n" +
            "AND chuanyun_day_log.sub_porject_id != '' && chuanyun_day_log.sub_porject_id IS NOT NULL\n" +
            "AND chuanyun_day_log.sub_project_bg != '' && chuanyun_day_log.sub_project_bg IS NOT NULL\n" +
            "GROUP BY\n" +
            "\tchuanyun_day_log.sub_porject_id,\n" +
            "\tchuanyun_log.user_id,\n" +
            "\tchuanyun_day_log.project_type,\n" +
            "\tchuanyun_log. STATUS,\n" +
            "\tchuanyun_day_log.day_log_date",nativeQuery = true)
    List<ChuanyunSubWorkHourDO> getSubSelfWorkHour(@Param("userId") String userId);


    @Query(value="SELECT chuanyun_day_log.object_id,\n" +
            "            SUM(chuanyun_day_log.hours_worked) AS hours_worked,\n" +
            "            chuanyun_day_log.sub_porject_id AS project_id,\n" +
            "            chuanyun_day_log.project_type,\n" +
            "            chuanyun_log.user_id,\n" +
            "            chuanyun_day_log.sub_project_bg AS bg,\n" +
            "            chuanyun_log.department_name,\n" +
            "            chuanyun_log.status,\n" +
            "            chuanyun_day_log.day_log_date \n" +
            "            FROM chuanyun_day_log \n" +
            "            LEFT JOIN chuanyun_log ON chuanyun_day_log.parent_object_id = chuanyun_log.object_id \n" +
            "            WHERE chuanyun_log.user_id = ?\n" +
            "            AND chuanyun_day_log.day_log_date =?\n" +
            "            AND status!=3 \n" +
            "            GROUP BY chuanyun_log.user_id,\n" +
            "            chuanyun_day_log.day_log_date",nativeQuery = true)
    ChuanyunSubWorkHourDO getSubDayWorkHour(String userId, LocalDateTime day);
}
