package com.galaxis.manatee.entity.chuanyun.data.object;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.galaxis.manatee.entity.chuanyun.data.object.BasicDO;
import com.galaxis.manatee.util.ChuanyunLocalDateTimeDeserializer;
import com.galaxis.manatee.util.ChuanyunLocalDateTimeSerializer;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.extern.slf4j.Slf4j;

import javax.persistence.Entity;
import java.math.BigDecimal;
import java.time.LocalDateTime;

@Slf4j
@EqualsAndHashCode(callSuper = true)
@Data
@Entity(name = "CHUANYUN_SUB_LABORCOST")
@JsonIgnoreProperties(ignoreUnknown = true)
public class ChuanyunSubLaborCostDO extends BasicDO {

    public static final String SCHEMA_CODE ="D001789Syexg3kma26vetik4ggte00nc0";

    @JsonProperty("F0000005")
    private String projectCode;

    @JsonProperty("F0000016")
    private String subProjectCode;

    @JsonSerialize(using = ChuanyunLocalDateTimeSerializer.class)
    @JsonDeserialize(using = ChuanyunLocalDateTimeDeserializer.class)
    @JsonProperty("F0000002")
    private LocalDateTime logDate;

    @JsonProperty("F0000017")
    private String department;

    @JsonProperty("F0000003")
    private BigDecimal amount;

    @JsonProperty("F0000004")
    private String dataType;
}
